# -*- coding: utf-8 -*-
# lorentz.py
import matplotlib
#matplotlib.use('TkAgg')
matplotlib.use('macosx')

#import Tkinter
#import FileDialog
#import tkFileDialog
#import tkMessageBox
import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D, proj3d

def orthogonal_proj(zfront, zback):
    a = (zfront+zback)/(zfront-zback)
    b = -2*(zfront*zback)/(zfront-zback)
    return np.array([[1,0,0,0],
                     [0,1,0,0],
                     [0,0,a,b],
                     [0,0,-1e-10,zback]])
proj3d.persp_transformation = orthogonal_proj

fig = plt.figure()
fig.canvas.set_window_title(u'Lorentz-transzformáció az xy-síkon')
ax = fig.gca(projection='3d', aspect='equal')

ALPHA = 0.5
LW = 2
MS = 10

ax.hold(True)

# Kek vonalak
ax.plot([0.0, 0.0], [0.0, 0.0], [0.0, 1.5], 'b-', lw=LW)
ax.plot([0.0, 0.0], [0.0, 1.5], [0.0, 0.0], 'b-', lw=LW)
ax.plot([0.0, 1.5], [0.0, 0.0], [0.0, 0.0], 'b-', lw=LW)
# Kek markerek
ax.plot([0.0], [0.0], [1.0], 'bo', alpha=ALPHA, ms=MS)
ax.plot([0.0], [1.0], [0.0], 'bo', alpha=ALPHA, ms=MS)
ax.plot([1.0], [0.0], [0.0], 'bo', alpha=ALPHA, ms=MS)

# Piros vonalak
ax.plot([0.0, 0.75], [0.0, 0.0], [0.0, 1.5], 'r-', lw=LW)
ax.plot([0.0, 0.0], [0.0, 1.5], [0.0, 0.0], 'r--', lw=LW)
ax.plot([0.0, 1.5], [0.0, 0.0], [0.0, 0.75], 'r-', lw=LW)
# Piros markerek
ax.plot([0.5774], [0.0], [1.1547], 'r*', alpha=ALPHA, ms=MS)
ax.plot([1.1547], [0.0], [0.5774], 'r*', alpha=ALPHA, ms=MS)
ax.plot([0.0], [1.0], [0.0], 'r*', alpha=ALPHA, ms=MS)

# Zold vonalak
ax.plot([0.0, 0.75], [0.0, 0.3897], [0.0, 1.5], 'g-', lw=LW)
ax.plot([0.0, 0.26], [0.0, 1.5], [0.0, 0.52], 'g-', lw=LW)
ax.plot([0.0, 1.5], [0.0, 0.0], [0.0, 0.75], 'g--', lw=LW)
# Zold markerek
ax.plot([0.605], [0.3145], [1.2105], 'gs', alpha=ALPHA, ms=MS)
ax.plot([1.1547], [0.0], [0.5774], 'gs', alpha=ALPHA, ms=MS)
ax.plot([0.1816], [1.0483], [0.3631], 'gs', alpha=ALPHA, ms=MS)

# Fekete vonalak
ax.plot([0.0, 0.75], [0.0, 0.3897], [0.0, 1.5], 'k--', lw=LW)
ax.plot([0.0, 1.5], [0.0, 0.1108], [0.0, 0.7788], 'k-', lw=LW)
ax.plot([0.0, 0.1236], [0.0, 1.5], [0.0, 0.4515], 'k-', lw=LW)
# Fekete markerek
ax.plot([0.605], [0.3145], [1.2105], 'k^', alpha=ALPHA, ms=MS)
ax.plot([1.1657], [0.0861], [0.6052], 'k^', alpha=ALPHA, ms=MS)
ax.plot([0.0861], [1.0447], [0.3145], 'k^', alpha=ALPHA, ms=MS)

ax.hold(False)

ax.set_xlim([0.0, 1.5])
ax.set_ylim([0.0, 1.5])
ax.set_zlim([0.0, 1.5])
ax.set_xlabel('x')
ax.set_ylabel('y')
ax.set_zlabel('ct')

ax.view_init(elev=15.0, azim=35.0)

# Uj perspektiva aktivalasa
fig.canvas.draw()

#ax.set_title(u'Lorentz-transzformáció az xy-síkon')

plt.show()
